package com.hai.dao;

import com.hai.entity.HighTyAgentPrice;
import com.hai.entity.HighTyAgentPriceExample.Criteria;
import com.hai.entity.HighTyAgentPriceExample.Criterion;
import com.hai.entity.HighTyAgentPriceExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class HighTyAgentPriceSqlProvider {

    public String countByExample(HighTyAgentPriceExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("high_ty_agent_price");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(HighTyAgentPriceExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("high_ty_agent_price");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(HighTyAgentPrice record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("high_ty_agent_price");
        
        if (record.getBelongType() != null) {
            sql.VALUES("belong_type", "#{belongType,jdbcType=INTEGER}");
        }
        
        if (record.getOilStationId() != null) {
            sql.VALUES("oil_station_id", "#{oilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilStationName() != null) {
            sql.VALUES("oil_station_name", "#{oilStationName,jdbcType=VARCHAR}");
        }
        
        if (record.getTyAgentOilStationId() != null) {
            sql.VALUES("ty_agent_oil_station_id", "#{tyAgentOilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilNoName() != null) {
            sql.VALUES("oil_no_name", "#{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.VALUES("oil_no", "#{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceRate() != null) {
            sql.VALUES("price_rate", "#{priceRate,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.VALUES("`status`", "#{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(HighTyAgentPriceExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("belong_type");
        sql.SELECT("oil_station_id");
        sql.SELECT("oil_station_name");
        sql.SELECT("ty_agent_oil_station_id");
        sql.SELECT("oil_no_name");
        sql.SELECT("oil_no");
        sql.SELECT("price_rate");
        sql.SELECT("`status`");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.FROM("high_ty_agent_price");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        HighTyAgentPrice record = (HighTyAgentPrice) parameter.get("record");
        HighTyAgentPriceExample example = (HighTyAgentPriceExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("high_ty_agent_price");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getBelongType() != null) {
            sql.SET("belong_type = #{record.belongType,jdbcType=INTEGER}");
        }
        
        if (record.getOilStationId() != null) {
            sql.SET("oil_station_id = #{record.oilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilStationName() != null) {
            sql.SET("oil_station_name = #{record.oilStationName,jdbcType=VARCHAR}");
        }
        
        if (record.getTyAgentOilStationId() != null) {
            sql.SET("ty_agent_oil_station_id = #{record.tyAgentOilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceRate() != null) {
            sql.SET("price_rate = #{record.priceRate,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("high_ty_agent_price");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("belong_type = #{record.belongType,jdbcType=INTEGER}");
        sql.SET("oil_station_id = #{record.oilStationId,jdbcType=BIGINT}");
        sql.SET("oil_station_name = #{record.oilStationName,jdbcType=VARCHAR}");
        sql.SET("ty_agent_oil_station_id = #{record.tyAgentOilStationId,jdbcType=BIGINT}");
        sql.SET("oil_no_name = #{record.oilNoName,jdbcType=VARCHAR}");
        sql.SET("oil_no = #{record.oilNo,jdbcType=VARCHAR}");
        sql.SET("price_rate = #{record.priceRate,jdbcType=DECIMAL}");
        sql.SET("`status` = #{record.status,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        
        HighTyAgentPriceExample example = (HighTyAgentPriceExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(HighTyAgentPrice record) {
        SQL sql = new SQL();
        sql.UPDATE("high_ty_agent_price");
        
        if (record.getBelongType() != null) {
            sql.SET("belong_type = #{belongType,jdbcType=INTEGER}");
        }
        
        if (record.getOilStationId() != null) {
            sql.SET("oil_station_id = #{oilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilStationName() != null) {
            sql.SET("oil_station_name = #{oilStationName,jdbcType=VARCHAR}");
        }
        
        if (record.getTyAgentOilStationId() != null) {
            sql.SET("ty_agent_oil_station_id = #{tyAgentOilStationId,jdbcType=BIGINT}");
        }
        
        if (record.getOilNoName() != null) {
            sql.SET("oil_no_name = #{oilNoName,jdbcType=VARCHAR}");
        }
        
        if (record.getOilNo() != null) {
            sql.SET("oil_no = #{oilNo,jdbcType=VARCHAR}");
        }
        
        if (record.getPriceRate() != null) {
            sql.SET("price_rate = #{priceRate,jdbcType=DECIMAL}");
        }
        
        if (record.getStatus() != null) {
            sql.SET("`status` = #{status,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, HighTyAgentPriceExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}